<?php
class Imager {

        function Imager() {
                $this->TempDir = '/tmp/';
                $this->Error = 3;
                $this->ErrorText = 'No Image Processed!';
                $this->FSize = 0;
                $this->ImgBin = '';
                $this->ImgDB = '';
                $this->ImgWidth = 0;
                $this->ImgHeight = 0;
                $this->ImgType = -1;
                $this->ImgTypeText = 'unknown';
        }



        function ProcessError($err) {
                $this->Error = $err;
                switch ($this->Error) {
                        case 0: $this->ErrorText = 'No error!'; break;
                        case 1: $this->ErrorText = 'Unknown Post Field!'; break;
                        case 2: $this->ErrorText = 'Unknown Image Format!'; break;
                        case 3: $this->ErrorText = 'No Image Processed!'; break;
                }
        }


        function GetProperties($fn) {
                $this->ImgBin = fread(fopen($fn, 'r'), filesize($fn));
                $imagesize = getimagesize($fn);
                $this->ImgWidth = $imagesize[0];
                $this->ImgHeight = $imagesize[1];
                $this->ImgType = $imagesize[2];
                switch ($this->ImgType) {
                        default:
                                $this->ImgType = -1;
                                $this->ImgTypeText = 'unknown';
                                $this->ProcessError(2);
                                return 2;
                        case 1: $this->ImgTypeText = 'GIF'; break;
                        case 2: $this->ImgTypeText = 'JPG'; break;
                        case 3: $this->ImgTypeText = 'PNG'; break;
                        case 4: $this->ImgTypeText = 'SWF'; break;
                        case 5: $this->ImgTypeText = 'PSD'; break;
                        case 6: $this->ImgTypeText = 'BMP'; break;
                        case 7: $this->ImgTypeText = 'TIFF'; break;
                        case 8: $this->ImgTypeText = 'TIFF'; break;
                        case 9: $this->ImgTypeText = 'JPC'; break;
                        case 10: $this->ImgTypeText = 'JP2'; break;
                        case 11: $this->ImgTypeText = 'JPX'; break;
                        case 12: $this->ImgTypeText = 'JB2'; break;
                        case 13: $this->ImgTypeText = 'SWC'; break;
                        case 14: $this->ImgTypeText = 'IFF'; break;
                }
        }



        function CreateThumb($imgfn, $thumbfn='', $size=100) {
                $this -> GetProperties($imgfn);
                switch($this->ImgType)  {
                        case 2: $source = imagecreatefromjpeg($imgfn); break;
                        case 3: $source = imagecreatefrompng($imgfn); break;
                }
                if ((ImageSX($source) <= $size) && (ImageSY($source) <= $size)) {
                           $h = ImageSY($source);
                           $w = ImageSX($source);
                }
                else  {
                           $w = $size;
                           $h = ImageSY($source) / (ImageSX($source) / $size);
                 }
                $dest = imagecreatetruecolor($w,$h);
                ImageCopyResized($dest, $source, 0, 0, 0, 0, $w, $h, ImageSX($source), ImageSY($source));
                if ($thumbfn) {
                        switch($this->ImgType)  {
                                case 2: imagejpeg($dest, $thumbfn, 85); break;
                                case 3: imagepng($dest, $thumbfn); break;
                        }
                }
                else {
                        switch($this->ImgType)  {
                                case 2: imagejpeg($dest, '', 85); break;
                                case 3: imagepng($dest); break;
                        }
                }
        }



        function PostImage($fldname) {
                unset($this->ImgBin);
                if (isset($_FILES[$fldname]['name']) && ($_FILES[$fldname]['name'] <> 'none') && ($_FILES[$fldname]['name'] <> '')){
                        $this->FSize = $_FILES[$fldname]['size'];
                        $fn = $_FILES[$fldname]['tmp_name'];
                        $this -> GetProperties($fn);
                }
                else {
                        $this->ProcessError(1);
                        return 1;
                }
                $this->ErrorText = '';
                $this->Error = 0;
                return 0;
        }



        function ImageDB() {
                if (!$this->ImgBin) {
                        $this->ProcessError(2);
                        return 2;
                }
                return addslashes($this->ImgBin);
        }



        function Thumb($size, $dest='') {
                global $PATH_TRANSLATED;
                $dest = dirname($PATH_TRANSLATED) . $this->TempDir . 'img.tmp';
                $fh = fopen($dest, 'w');
                fwrite($fh, $this->ImgBin);
                fclose($fh);
                switch($this->ImgType)  {
                        case 2: $source = ImageCreateFromJPEG($dest); break;
                        case 3: $source = ImageCreateFromPNG($dest); break;
                }
                if ((ImageSX($source) <= $size) && (ImageSY($source) <= $size)) {
                           $h = ImageSY($source);
                           $w = ImageSX($source);
                }
                else  {
                           $w = $size;
                           $h = ImageSY($source) / (ImageSX($source) / $size);
                 }
                $dest = imagecreate($w,$h);
                ImageCopyResized($dest, $source, 0, 0, 0, 0, $w, $h, ImageSX($source), ImageSY($source));
                $thumbname = dirname($PATH_TRANSLATED) . $this->TempDir . 'thumb.tmp';
                switch($this->ImgType)  {
                        case 2: imagejpeg($dest, $thumbname, 85); break;
                        case 3: imagepng($dest, $thumbname); break;
                }
                $dest = fread(fopen($thumbname, "r"), filesize($thumbname));
                return $dest;
        }



        function TumbDB($size) {
                if (!$this->ImgBin) {
                        $this->ProcessError(2);
                        return 2;
                }
                return addslashes($this->Thumb($size));
        }



        function SaveImgToFile($fname) {
                $fh = fopen($fname, 'w');
                fwrite($fh, $this->ImgBin);
                fclose($fh);
        }

}

?>